## ocaml-batteries 2.4

=== Makefile ===
# A basic Makefile for building and installing Batteries Included
# It punts to ocamlbuild for all the heavy lifting.

NAME = batteries

VERSION := $(shell grep "^Version:" _oasis | cut -c 15-)
OCAML_MAJOR_VERSION := $(firstword $(subst ., , $(shell ocamlfind ocamlc -version)))
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

# Define variables and export them for mkconf.ml
DOCROOT ?= /usr/share/doc/ocaml-batteries
export DOCROOT
BROWSER_COMMAND ?= x-www-browser
export BROWSER_COMMAND

OCAMLBUILD ?= ocamlbuild
OCAMLBUILDFLAGS ?= -no-links -use-ocamlfind

ifeq ($(uname_S),Darwin)
  BATTERIES_NATIVE ?= yes
  BATTERIES_NATIVE_SHLIB ?= no
else
  BATTERIES_NATIVE ?= yes
  BATTERIES_NATIVE_SHLIB ?= $(BATTERIES_NATIVE)
endif

# Directory where to build the qtest suite
QTESTDIR ?= qtest

INSTALL_FILES = _build/META _build/src/*.cma \
	battop.ml _build/src/*.cmi _build/src/*.mli \
	_build/src/batteriesHelp.cmo _build/src/batteriesConfig.cmo _build/src/batteriesPrint.cmo \
	ocamlinit build/ocaml
OPT_INSTALL_FILES = _build/src/*.cmx _build/src/*.a _build/src/*.cmxa \
	_build/src/*.cmxs _build/src/*.lib

# What to build
TARGETS  = src/batteries.cma
TARGETS += src/batteriesHelp.cmo
TARGETS += src/batteriesThread.cma
TARGETS += META
BENCH_TARGETS  = benchsuite/bench_int.native
BENCH_TARGETS += benchsuite/flip.native
BENCH_TARGETS += benchsuite/deque.native
BENCH_TARGETS += benchsuite/lines_of.native
BENCH_TARGETS += benchsuite/bitset.native
BENCH_TARGETS += benchsuite/bench_map.native
BENCH_TARGETS += benchsuite/bench_nreplace.native
TEST_TARGET = test-byte

ifeq ($(BATTERIES_NATIVE_SHLIB), yes)
  EXT = native
  MODE = shared
  TARGETS += src/batteries.cmxs src/batteriesThread.cmxs
  TEST_TARGET = test-native
else
ifeq ($(BATTERIES_NATIVE), yes)
  EXT = native
  MODE = native
  TARGETS += src/batteries.cmxa src/batteriesThread.cmxa
  TEST_TARGET = test-native
else
  EXT = byte
  MODE = bytecode
endif
endif

.PHONY: all clean doc install uninstall reinstall test qtest qtest-clean camfail camfailunk coverage man

all:
	@echo "Build mode:" $(MODE)
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) $(TARGETS)

clean:
	@${RM} src/batteriesConfig.ml src/batUnix.mli batteries.odocl \
	  bench.log $(QTESTDIR)/all_tests.ml
	@${RM} -r man/
	@$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -clean
	@echo " Cleaned up working copy" # Note: ocamlbuild eats the first char!

batteries.odocl: src/batteries.mllib src/batteriesThread.mllib
	cat $^ > $@

doc: batteries.odocl
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) batteries.docdir/index.html

man: all batteries.odocl
	-mkdir man
	ocamlfind ocamldoc -package threads.posix -sort -man -hide-warnings -d man -I _build/libs -I _build/src libs/uniclib.mli src/*.mli

install: all uninstall_packages
	ocamlfind install $(NAME) $(INSTALL_FILES) \
		-optional $(OPT_INSTALL_FILES)

uninstall_packages:
	ocamlfind remove $(NAME)

uninstall: uninstall_packages
	${RM} -r $(DOCROOT)

install-doc: doc
	mkdir -p $(DOCROOT)
	mkdir -p $(DOCROOT)/html/api
	cp _build/batteries.docdir/* $(DOCROOT)/html/api
	cp LICENSE README.md FAQ $(DOCROOT)

install-man: man
	install man/* /usr/local/man/man3/

reinstall:
	$(MAKE) uninstall
	$(MAKE) install

###############################################################################
#      Pre-Processing of Source Code
###############################################################################

# the prefilter logic has moved to myocamlbuild.ml
# we keep the two void rules below for backward-compatibility for now
# (devs may have scripts calling them)
#
# For the record, and the ease of porting the build system to
# something else, the "prefilter" step preprocessed each file whose
# extension ends with a 'v', for example '.mliv', using the command
#     build/prefilter.byte foo.mliv > foo.mli

prefilter:
clean-prefilter:

###############################################################################
#	BUILDING AND RUNNING UNIT TESTS
###############################################################################

### List of source files that it's okay to try to test

DONTTEST=src/batteriesHelp.ml
TESTABLE ?= $(filter-out $(DONTTEST), $(wildcard src/*.ml))
TESTDEPS = $(TESTABLE)

### Test suite: "offline" unit tests
##############################################

_build/testsuite/main.byte: $(TESTDEPS) $(wildcard testsuite/*.ml)
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) testsuite/main.byte
_build/testsuite/main.native: $(TESTDEPS) $(wildcard testsuite/*.ml)
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) testsuite/main.native

### qtest: "inline" unit tests
##############################################


# extract all qtest unit tests into a single ml file
$(QTESTDIR)/all_tests.ml: $(TESTABLE)
	qtest -o $@ --shuffle --preamble-file qtest/qtest_preamble.ml extract $(TESTABLE)

_build/$(QTESTDIR)/all_tests.byte: $(QTESTDIR)/all_tests.ml
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -cflags -warn-error,+26 -pkg oUnit,QTest2Lib $(QTESTDIR)/all_tests.byte
_build/$(QTESTDIR)/all_tests.native: $(QTESTDIR)/all_tests.ml
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -cflags -warn-error,+26 -pkg oUnit,QTest2Lib $(QTESTDIR)/all_tests.native


### qtest: quick run of inline unit tests
##############################################
# $ make qtest TESTABLE=foo.ml
# will only test the module Foo.

qtest-byte-clean:
	@${RM} $(QTESTDIR)/all_tests.ml
	@${MAKE} _build/$(QTESTDIR)/all_tests.byte

qtest-byte: qtest-byte-clean
	@_build/$(QTESTDIR)/all_tests.byte

qtest-native-clean:
	@${RM} $(QTESTDIR)/all_tests.ml
	@${MAKE} _build/$(QTESTDIR)/all_tests.native

qtest-native: prefilter qtest-native-clean
	@_build/$(QTESTDIR)/all_tests.native

qtest-clean:
	@${RM} $(QTESTDIR)/all_tests.ml
	@${MAKE} _build/$(QTESTDIR)/all_tests.$(EXT)

qtest: qtest-clean
	@_build/$(QTESTDIR)/all_tests.$(EXT)

### run all unit tests
##############################################

testsuite-only-byte: _build/testsuite/main.byte
	@_build/testsuite/main.byte
	@echo "" # newline after "OK"

testsuite-only-native: _build/testsuite/main.native
	@_build/testsuite/main.native
	@echo "" # newline after "OK"

test-byte: qtest-byte testsuite-only-byte

test-native: qtest-native testsuite-only-native

full-test: $(TEST_TARGET)

test-compat: src/batteries_compattest.ml
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) src/batteries_compattest.byte

test: test-byte test-compat

###############################################################################
#	BENCHMARK SUITE
###############################################################################

bench:
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) $(TARGETS) $(BENCH_TARGETS)
	$(RM) bench.log
	$(foreach BENCH, $(BENCH_TARGETS), _build/$(BENCH) | tee -a bench.log; )
	@echo "Benchmarking results are written to bench.log"


###############################################################################
#	PREPARING RELEASE FILES
###############################################################################

release:
	$(MAKE) clean
	git stash save "stashing local modifications before release"
	$(MAKE) release-cleaned

# assumes irreproachably pristine working directory
release-cleaned: setup.ml doc test
	git archive --format=tar --prefix=batteries-$(VERSION)/ HEAD \
	  | gzip > batteries-$(VERSION).tar.gz

setup.ml: _oasis
	oasis setup
	git commit setup.ml -m"Update setup.ml based on _oasis"


# uploads the current documentation to github hdoc2/ directory
upload-docs:
	make doc && git checkout gh-pages && rm -f hdoc2/*.html && cp _build/batteries.docdir/*.html hdoc2/ && git add hdoc2/*.html && git commit -a -m"Update to latest documentation" && git push github gh-pages

###############################################################################
#	CODE COVERAGE REPORTS
###############################################################################

coverage/index.html: $(TESTDEPS) $(QTESTDIR)/all_tests.ml
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) coverage/index.html

coverage: coverage/index.html

=== debian/changelog ===
ocaml-batteries (2.4-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches
    - Remove 0002-Disable-qtest-based-tests.patch, fixed upstream.
    - Remove 0003-Disable-test-compat-broken-with-OCaml-4.01.0.patch, no longer
      relevant.

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 23 Dec 2015 00:27:08 +0100

ocaml-batteries (2.3-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 10 Oct 2015 21:51:19 +0200

=== debian/control ===
Source: ocaml-batteries
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 7.0.50),
 ocaml-nox (>= 4),
 camlp4, camlp4-extra,
 ocaml-findlib (>= 1.4),
 libcamomile-ocaml-dev (>= 0.8),
 libounit-ocaml-dev,
 dh-ocaml (>= 0.9.5~)
Standards-Version: 3.9.2
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-batteries.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-batteries.git
Homepage: http://batteries.forge.ocamlcore.org

Package: libbatteries-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: libbatteries-ocaml-doc
Suggests: ledit
Provides:
 libbatteries-camlp4-dev,
 ${ocaml:Provides}
Description: Batteries included: OCaml development platform - development files
 Batteries included is a community-driven effort to standardize on an
 uniform, documented, and comprehensive OCaml development platform.
 .
 Batteries included serves the following purposes:
  * define a standard set of libraries which may be expected on every
    compliant installation of OCaml
  * organize these libraries into a hierarchy of modules, with one
    source of documentation
  * define a standard set of language extensions which may be expected
    on every compliant installation of OCaml
  * provide a consistent API for otherwise independent libraries.
 .
 This package contains the core part of batteries included: libraries
 and language extensions for the OCaml language. Using this package
 you can develop OCaml programs built on top of batteries included.

Package: libbatteries-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Batteries included - OCaml development platform - documentation
 Batteries included is a community-driven effort to standardize on an
 uniform, documented, and comprehensive OCaml development platform.
 .
 Batteries included serves the following purposes:
  * define a standard set of libraries which may be expected on every
    compliant installation of OCaml
  * organize these libraries into a hierarchy of modules, with one
    source of documentation
  * define a standard set of language extensions which may be expected
    on every compliant installation of OCaml
  * provide a consistent API for otherwise independent libraries.
 .
 This package contains the documentation for batteries included: HTML
 API documentation, examples, and information about how to use
 batteries included in your programs.

Package: ocaml-batteries-included
Architecture: all
Depends:
 libbatteries-ocaml-dev,
 libbatteries-camlp4-dev,
 libbatteries-ocaml-doc,
 ${misc:Depends}
Description: Batteries included: OCaml development platform - metapackage
 Batteries included is a community-driven effort to standardize on an
 uniform, documented, and comprehensive OCaml development platform.
 .
 Batteries included serves the following purposes:
  * define a standard set of libraries which may be expected on every
    compliant installation of OCaml
  * organize these libraries into a hierarchy of modules, with one
    source of documentation
  * define a standard set of language extensions which may be expected
    on every compliant installation of OCaml
  * provide a consistent API for otherwise independent libraries.
 .
 This metapackage is provided for convenience, to install all of
 batteries included at once.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR = $(CURDIR)/debian/tmp/$(OCAML_STDLIB_DIR)
BATTERIES_DEB_DOCROOT = $(CURDIR)/debian/tmp/doc
export BATTERIES_DOCROOT = /usr/share/doc/libbatteries-ocaml-doc/
export DESTDIR = $(OCAML_STDLIB_DIR)
DOC_PKG = libbatteries-ocaml-doc

%:
	dh --with ocaml $@

ifneq ($(OCAML_HAVE_OCAMLOPT),yes)
export BATTERIES_NATIVE = false
endif

ifneq ($(OCAML_NATDYNLINK),yes)
export BATTERIES_NATIVE_SHLIB=false
endif

override_dh_auto_build:
	make DOCROOT=$(BATTERIES_DOCROOT) all
ifneq (,$(findstring $(DOC_PKG),$(shell dh_listpackages)))
	make doc
endif

override_dh_auto_test:
	make test

override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR)/batteries $(BATTERIES_DEB_DOCROOT)
	make DESTDIR=$(OCAMLFIND_DESTDIR) install
ifneq (,$(findstring $(DOC_PKG),$(shell dh_listpackages)))
	make DOCROOT=$(BATTERIES_DEB_DOCROOT) install-doc
endif

override_dh_auto_clean:
	make clean
	rm -rf man/ .omakedb .omakedb.lock
	-find . -name '*.omc' -exec rm {} \;

override_dh_compress:
	dh_compress -Xmyocamlbuild.ml -X.idex

.PHONY: override_dh_auto_build override_dh_auto_test override_dh_auto_install
.PHONY: override_dh_auto_clean override_dh_compress

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

## ocaml-batteries 2.5.3

=== debian/changelog ===
ocaml-batteries (2.5.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Add ocamlbuild to Build-Depends
  * Update Vcs-*
  * Bump debhelper compat to 10

 -- Stéphane Glondu <glondu@debian.org>  Wed, 19 Jul 2017 20:11:24 +0200

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,17 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Mehdi Dogguy <mehdi@debian.org>
 Build-Depends:
- debhelper (>= 7.0.50),
+ debhelper (>= 10),
  ocaml-nox (>= 4),
  camlp4, camlp4-extra,
  ocaml-findlib (>= 1.4),
  libcamomile-ocaml-dev (>= 0.8),
  libounit-ocaml-dev,
+ ocamlbuild,
  dh-ocaml (>= 0.9.5~)
 Standards-Version: 3.9.2
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocaml-batteries.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocaml-batteries.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-batteries.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-batteries.git
 Homepage: http://batteries.forge.ocamlcore.org
 
 Package: libbatteries-ocaml-dev

## ocaml-batteries 2.6.0

=== Makefile ===
--- 
+++ 
@@ -27,10 +27,25 @@
 # Directory where to build the qtest suite
 QTESTDIR ?= qtest
 
+ifeq ($(shell ocamlfind query -p-format qcheck),qcheck)
+	QTESTPKG = qcheck
+else
+	QTESTPKG = QTest2Lib
+endif
+
 INSTALL_FILES = _build/META _build/src/*.cma \
 	battop.ml _build/src/*.cmi _build/src/*.mli \
 	_build/src/batteriesHelp.cmo _build/src/batteriesConfig.cmo _build/src/batteriesPrint.cmo \
 	ocamlinit build/ocaml
+# the bin_annot flag in _tags is not handled by versions of ocamlbuild < 4.01.0
+# hence we only install *.cmt{i} files if they were produced
+ifneq ($(wildcard _build/src/*.cmt),)
+	INSTALL_FILES += _build/src/*.cmt
+endif
+ifneq ($(wildcard _build/src/*.cmti),)
+	INSTALL_FILES += _build/src/*.cmti
+endif
+
 OPT_INSTALL_FILES = _build/src/*.cmx _build/src/*.a _build/src/*.cmxa \
 	_build/src/*.cmxs _build/src/*.lib
 
@@ -65,7 +80,7 @@
 endif
 endif
 
-.PHONY: all clean doc install uninstall reinstall test qtest qtest-clean camfail camfailunk coverage man
+.PHONY: all clean doc install uninstall reinstall test qtest qtest-clean camfail camfailunk coverage man test_install
 
 all:
 	@echo "Build mode:" $(MODE)
@@ -91,6 +106,9 @@
 install: all uninstall_packages
 	ocamlfind install $(NAME) $(INSTALL_FILES) \
 		-optional $(OPT_INSTALL_FILES)
+
+test_install:
+	./scripts/test_install.sh
 
 uninstall_packages:
 	ocamlfind remove $(NAME)
@@ -133,9 +151,24 @@
 
 ### List of source files that it's okay to try to test
 
-DONTTEST=src/batteriesHelp.ml
-TESTABLE ?= $(filter-out $(DONTTEST), $(wildcard src/*.ml))
+# TESTABLE contains the source files as the user sees them,
+# as a mix of .ml and .mlv files in the src/ directory
+
+# TESTDEPS represents the file whose changes Makefile should watch to
+# decide to reprocess the test results. It is identical to TESTABLE.
+
+# TESTFILES contains the OCaml source files as `qtest` wants to see
+# them, that is after preprocessing. We ask ocamlbuild to build the
+# $(TESTFILES) from $(TESTABLE), and pass them to qtest from the
+# `_build` directory.
+
+DONTTEST=src/batteriesHelp.ml \
+	 src/batConcreteQueue_402.ml src/batConcreteQueue_403.ml
+TESTABLE ?= $(filter-out $(DONTTEST),\
+   $(wildcard src/*.ml) $(wildcard src/*.mlv))
 TESTDEPS = $(TESTABLE)
+
+TESTFILES = $(TESTABLE:.mlv=.ml)
 
 ### Test suite: "offline" unit tests
 ##############################################
@@ -151,12 +184,17 @@
 
 # extract all qtest unit tests into a single ml file
 $(QTESTDIR)/all_tests.ml: $(TESTABLE)
-	qtest -o $@ --shuffle --preamble-file qtest/qtest_preamble.ml extract $(TESTABLE)
+	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) $(TESTFILES)
+	(cd _build; qtest -o ../$@ --shuffle \
+	  --preamble-file ../qtest/qtest_preamble.ml \
+	  extract $(TESTFILES))
 
 _build/$(QTESTDIR)/all_tests.byte: $(QTESTDIR)/all_tests.ml
-	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -cflags -warn-error,+26 -pkg oUnit,QTest2Lib $(QTESTDIR)/all_tests.byte
+	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -cflags -warn-error,+26\
+		-pkg oUnit,$(QTESTPKG) $(QTESTDIR)/all_tests.byte
 _build/$(QTESTDIR)/all_tests.native: $(QTESTDIR)/all_tests.ml
-	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -cflags -warn-error,+26 -pkg oUnit,QTest2Lib $(QTESTDIR)/all_tests.native
+	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -cflags -warn-error,+26\
+		-pkg oUnit,$(QTESTPKG) $(QTESTDIR)/all_tests.native
 
 
 ### qtest: quick run of inline unit tests
@@ -204,6 +242,9 @@
 
 test-compat: src/batteries_compattest.ml
 	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) src/batteries_compattest.byte
+
+test-build-from-install:
+	$(MAKE) -C test-build
 
 test: test-byte test-compat

=== test-build/Makefile ===
# This test is designed to catch build issues that affect installed
# versions of the library, such as the ones that plagued v2.5.0 and
# v2.5.1 -- forgetting to include a new module in src/batteries.mllib,
# which results in a link-time error when building from an installed
# version.
all:
	ocamlfind ocamlopt -package batteries -o test -linkpkg test.ml
	./test | grep --quiet "0123456789" || exit 2
	rm test.cm* test.o test

=== debian/changelog ===
ocaml-batteries (2.6.0-1build1) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 13:35:59 +0200

ocaml-batteries (2.6.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Fix FTBFS with OCaml 4.05

 -- Stéphane Glondu <glondu@debian.org>  Thu, 20 Jul 2017 10:50:40 +0200

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 DOC_PKG = libbatteries-ocaml-doc
 
 %:
-	dh --with ocaml $@
+	dh $@ --with ocaml
 
 ifneq ($(OCAML_HAVE_OCAMLOPT),yes)
 export BATTERIES_NATIVE = false

=== debian/watch ===
version=3
https://github.com/ocaml-batteries-team/batteries-included/releases .*/v(.*)\.tar\.gz

## ocaml-batteries 2.10.0

=== Makefile ===
--- 
+++ 
@@ -48,6 +48,12 @@
 
 OPT_INSTALL_FILES = _build/src/*.cmx _build/src/*.a _build/src/*.cmxa \
 	_build/src/*.cmxs _build/src/*.lib
+
+ifneq ($(QTEST_SEED),)
+	QTEST_SEED_FLAG = --seed $(QTEST_SEED)
+else
+	QTEST_SEED_FLAG =
+endif
 
 # What to build
 TARGETS  = src/batteries.cma
@@ -80,7 +86,7 @@
 endif
 endif
 
-.PHONY: all clean doc install uninstall reinstall test qtest qtest-clean camfail camfailunk coverage man test_install
+.PHONY: all clean doc install uninstall reinstall test qtest qtest-clean camfail camfailunk man test_install
 
 all:
 	@echo "Build mode:" $(MODE)
@@ -163,6 +169,7 @@
 # `_build` directory.
 
 DONTTEST=src/batteriesHelp.ml \
+	 src/batteries_compattest.ml \
 	 src/batConcreteQueue_402.ml src/batConcreteQueue_403.ml
 TESTABLE ?= $(filter-out $(DONTTEST),\
    $(wildcard src/*.ml) $(wildcard src/*.mlv))
@@ -207,21 +214,22 @@
 	@${MAKE} _build/$(QTESTDIR)/all_tests.byte
 
 qtest-byte: qtest-byte-clean
-	@_build/$(QTESTDIR)/all_tests.byte
+	@_build/$(QTESTDIR)/all_tests.byte $(QTEST_SEED_FLAG)
 
 qtest-native-clean:
 	@${RM} $(QTESTDIR)/all_tests.ml
-	@${MAKE} _build/$(QTESTDIR)/all_tests.native
+	@${MAKE} _build/$(QTESTDIR)/all_tests.native $(QTEST_SEED_FLAG)
 
 qtest-native: prefilter qtest-native-clean
-	@_build/$(QTESTDIR)/all_tests.native
+	@_build/$(QTESTDIR)/all_tests.native $(QTEST_SEED_FLAG)
 
 qtest-clean:
 	@${RM} $(QTESTDIR)/all_tests.ml
 	@${MAKE} _build/$(QTESTDIR)/all_tests.$(EXT)
 
 qtest: qtest-clean
-	@_build/$(QTESTDIR)/all_tests.$(EXT)
+	@_build/$(QTESTDIR)/all_tests.$(EXT) $(QTEST_SEED_FLAG)
+
 
 ### run all unit tests
 ##############################################
@@ -269,7 +277,7 @@
 	$(MAKE) release-cleaned
 
 # assumes irreproachably pristine working directory
-release-cleaned: setup.ml doc test
+release-cleaned: setup.ml doc test-native
 	git archive --format=tar --prefix=batteries-$(VERSION)/ HEAD \
 	  | gzip > batteries-$(VERSION).tar.gz
 
@@ -281,12 +289,3 @@
 # uploads the current documentation to github hdoc2/ directory
 upload-docs:
 	make doc && git checkout gh-pages && rm -f hdoc2/*.html && cp _build/batteries.docdir/*.html hdoc2/ && git add hdoc2/*.html && git commit -a -m"Update to latest documentation" && git push github gh-pages
-
-###############################################################################
-#	CODE COVERAGE REPORTS
-###############################################################################
-
-coverage/index.html: $(TESTDEPS) $(QTESTDIR)/all_tests.ml
-	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) coverage/index.html
-
-coverage: coverage/index.html

=== debian/changelog ===
ocaml-batteries (2.10.0-1build2) focal; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Feb 2020 22:16:18 +0100

ocaml-batteries (2.10.0-1build1) focal; urgency=medium

  * No-change rebuild against ocaml-nox-4.08.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Feb 2020 07:28:06 +0000

ocaml-batteries (2.10.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Add libnum-ocaml-dev to Build-Depends
  * Update Vcs-*
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Tue, 12 Nov 2019 10:49:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ocaml-batteries
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Mehdi Dogguy <mehdi@debian.org>
 Build-Depends:
  debhelper (>= 10),
@@ -10,12 +11,13 @@
  ocaml-findlib (>= 1.4),
  libcamomile-ocaml-dev (>= 0.8),
  libounit-ocaml-dev,
+ libnum-ocaml-dev,
  ocamlbuild,
  dh-ocaml (>= 0.9.5~)
 Standards-Version: 3.9.2
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-batteries.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-batteries.git
-Homepage: http://batteries.forge.ocamlcore.org
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-batteries.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-batteries
+Homepage: https://github.com/ocaml-batteries-team/batteries-included
 
 Package: libbatteries-ocaml-dev
 Architecture: any

=== debian/watch ===
version=3
opts="uversionmangle=s/_test_/~test~/" \
https://github.com/ocaml-batteries-team/batteries-included/releases .*/archive/v(.*)\.tar\.gz

## ocaml-batteries 3.1.0

=== Makefile ===
--- 
+++ 
@@ -169,7 +169,7 @@
 # `_build` directory.
 
 DONTTEST=src/batteriesHelp.ml \
-	 src/batteries_compattest.ml \
+	 src/batteries_compattest.mlv \
 	 src/batConcreteQueue_402.ml src/batConcreteQueue_403.ml
 TESTABLE ?= $(filter-out $(DONTTEST),\
    $(wildcard src/*.ml) $(wildcard src/*.mlv))
@@ -248,6 +248,13 @@
 
 full-test: $(TEST_TARGET)
 
+PREFILTER_BIN = _build/build/prefilter.byte
+# FIXME: Not sure what actually produces this binary:
+$(PREFILTER_BIN): all
+# FIXME: Should probably be done by ocamlbuild somehow:
+src/batteries_compattest.ml: src/batteries_compattest.mlv $(PREFILTER_BIN)
+	$(PREFILTER_BIN) < $< > $@
+
 test-compat: src/batteries_compattest.ml
 	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) src/batteries_compattest.byte
 
@@ -288,4 +295,14 @@
 
 # uploads the current documentation to github hdoc2/ directory
 upload-docs:
-	make doc && git checkout gh-pages && rm -f hdoc2/*.html && cp _build/batteries.docdir/*.html hdoc2/ && git add hdoc2/*.html && git commit -a -m"Update to latest documentation" && git push github gh-pages
+	make doc && \
+	rm -rf /tmp/batteries.docdir && \
+	cp -a _build/batteries.docdir /tmp/ && \
+	git checkout gh-pages && \
+	rm -f hdoc2/*.html && \
+	cp /tmp/batteries.docdir/*.html hdoc2/ && \
+	git add hdoc2/*.html && \
+	git commit hdoc2 -m "Update ocamldoc to latest release" && \
+	git push \
+	git@github.com:ocaml-batteries-team/batteries-included.git gh-pages \
+	git checkout master

=== debian/changelog ===
ocaml-batteries (3.1.0-2) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Do not install battop.ml (Closes: #985286)

  [ Debian Janitor ]
  * libbatteries-ocaml-doc: Add Multi-Arch: foreign.

 -- Stéphane Glondu <glondu@debian.org>  Sun, 21 Mar 2021 10:57:36 +0100

ocaml-batteries (3.1.0-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Stéphane Glondu <glondu@debian.org>  Fri, 11 Sep 2020 10:43:39 +0200

ocaml-batteries (3.0.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Thu, 06 Aug 2020 13:39:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,18 @@
 Source: ocaml-batteries
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Mehdi Dogguy <mehdi@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper-compat (= 13),
  ocaml-nox (>= 4),
- camlp4, camlp4-extra,
- ocaml-findlib (>= 1.4),
- libcamomile-ocaml-dev (>= 0.8),
+ ocaml-findlib,
  libounit-ocaml-dev,
  libnum-ocaml-dev,
  ocamlbuild,
- dh-ocaml (>= 0.9.5~)
-Standards-Version: 3.9.2
+ dh-ocaml
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-batteries.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-batteries
 Homepage: https://github.com/ocaml-batteries-team/batteries-included
@@ -28,9 +26,7 @@
  ${misc:Depends}
 Recommends: libbatteries-ocaml-doc
 Suggests: ledit
-Provides:
- libbatteries-camlp4-dev,
- ${ocaml:Provides}
+Provides: ${ocaml:Provides}
 Description: Batteries included: OCaml development platform - development files
  Batteries included is a community-driven effort to standardize on an
  uniform, documented, and comprehensive OCaml development platform.
@@ -52,6 +48,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Batteries included - OCaml development platform - documentation
  Batteries included is a community-driven effort to standardize on an
  uniform, documented, and comprehensive OCaml development platform.
@@ -73,7 +70,6 @@
 Architecture: all
 Depends:
  libbatteries-ocaml-dev,
- libbatteries-camlp4-dev,
  libbatteries-ocaml-doc,
  ${misc:Depends}
 Description: Batteries included: OCaml development platform - metapackage

## ocaml-batteries 3.4.0

=== Makefile ===
--- 
+++ 
@@ -33,21 +33,34 @@
 	QTESTPKG = QTest2Lib
 endif
 
-INSTALL_FILES = _build/META _build/src/*.cma \
-	battop.ml _build/src/*.cmi _build/src/*.mli \
-	_build/src/batteriesHelp.cmo _build/src/batteriesConfig.cmo _build/src/batteriesPrint.cmo \
-	ocamlinit build/ocaml
+INSTALL_FILES = _build/META _build/src/*.cma _build/src/*.cmi _build/src/*.mli \
+	toplevel/battop.ml _build/toplevel/*.cmi _build/toplevel/*.mli \
+# Note: we do not currently install
+#       _build/toplevel/*.cma
+# as there are no such files. If you create a proper library for batteries-help, you need to add *.cma
+# to INSTALL_FILES.
+
+INSTALL_FILES += \
+	_build/src/batteriesConfig.cmo _build/src/batteriesPrint.cmo _build/toplevel/batteriesHelp.cmo \
+	toplevel/ocamlinit build/ocaml
+
 # the bin_annot flag in _tags is not handled by versions of ocamlbuild < 4.01.0
 # hence we only install *.cmt{i} files if they were produced
 ifneq ($(wildcard _build/src/*.cmt),)
 	INSTALL_FILES += _build/src/*.cmt
-endif
+	INSTALL_FILES += _build/toplevel/*.cmt
+endif
+
 ifneq ($(wildcard _build/src/*.cmti),)
 	INSTALL_FILES += _build/src/*.cmti
-endif
-
-OPT_INSTALL_FILES = _build/src/*.cmx _build/src/*.a _build/src/*.cmxa \
-	_build/src/*.cmxs _build/src/*.lib
+	INSTALL_FILES += _build/toplevel/*.cmti
+endif
+
+OPT_INSTALL_FILES = \
+	_build/src/*.cmx _build/src/*.cmxa _build/src/*.cmxs \
+	_build/src/*.a _build/src/*.lib \
+	_build/toplevel/*.cmx _build/toplevel/*.cmxa _build/toplevel/*.cmxs \
+	_build/toplevel/*.a _build/toplevel/*.lib
 
 ifneq ($(QTEST_SEED),)
 	QTEST_SEED_FLAG = --seed $(QTEST_SEED)
@@ -57,7 +70,7 @@
 
 # What to build
 TARGETS  = src/batteries.cma
-TARGETS += src/batteriesHelp.cmo
+TARGETS += toplevel/batteriesHelp.cmo
 TARGETS += src/batteriesThread.cma
 TARGETS += META
 BENCH_TARGETS  = benchsuite/bench_int.native
@@ -67,6 +80,7 @@
 BENCH_TARGETS += benchsuite/bitset.native
 BENCH_TARGETS += benchsuite/bench_map.native
 BENCH_TARGETS += benchsuite/bench_nreplace.native
+BENCH_TARGETS += benchsuite/bench_set_to_seq.native
 TEST_TARGET = test-byte
 
 ifeq ($(BATTERIES_NATIVE_SHLIB), yes)
@@ -86,7 +100,7 @@
 endif
 endif
 
-.PHONY: all clean doc install uninstall reinstall test qtest qtest-clean camfail camfailunk man test_install
+.PHONY: all clean deps doc install uninstall reinstall test qtest qtest-clean camfail camfailunk man test_install
 
 all:
 	@echo "Build mode:" $(MODE)
@@ -94,7 +108,7 @@
 
 clean:
 	@${RM} src/batteriesConfig.ml src/batUnix.mli batteries.odocl \
-	  bench.log $(QTESTDIR)/all_tests.ml
+	  bench.log $(QTESTDIR)/all_tests.ml src/batteries_compattest.ml
 	@${RM} -r man/
 	@$(OCAMLBUILD) $(OCAMLBUILDFLAGS) -clean
 	@echo " Cleaned up working copy" # Note: ocamlbuild eats the first char!
@@ -104,6 +118,12 @@
 
 doc: batteries.odocl
 	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) batteries.docdir/index.html
+
+PREFILTER_BIN = _build/build/prefilter.byte
+# compute human-readable dependencies between modules
+deps: $(PREFILTER_BIN)
+	ocamldep -modules -all -one-line -ml-synonym .mlv -mli-synonym .mliv \
+	  -pp $(PREFILTER_BIN) src/*.ml src/*.mlv src/*.mliv src/*.mli > dependencies.txt
 
 man: all batteries.odocl
 	-mkdir man
@@ -168,8 +188,7 @@
 # $(TESTFILES) from $(TESTABLE), and pass them to qtest from the
 # `_build` directory.
 
-DONTTEST=src/batteriesHelp.ml \
-	 src/batteries_compattest.mlv \
+DONTTEST=src/batteries_compattest.mlv \
 	 src/batConcreteQueue_402.ml src/batConcreteQueue_403.ml
 TESTABLE ?= $(filter-out $(DONTTEST),\
    $(wildcard src/*.ml) $(wildcard src/*.mlv))
@@ -248,9 +267,8 @@
 
 full-test: $(TEST_TARGET)
 
-PREFILTER_BIN = _build/build/prefilter.byte
-# FIXME: Not sure what actually produces this binary:
-$(PREFILTER_BIN): all
+$(PREFILTER_BIN): build/prefilter.ml
+	$(OCAMLBUILD) build/prefilter.byte
 # FIXME: Should probably be done by ocamlbuild somehow:
 src/batteries_compattest.ml: src/batteries_compattest.mlv $(PREFILTER_BIN)
 	$(PREFILTER_BIN) < $< > $@
@@ -286,12 +304,11 @@
 # assumes irreproachably pristine working directory
 release-cleaned: setup.ml doc test-native
 	git archive --format=tar --prefix=batteries-$(VERSION)/ HEAD \
-	  | gzip > batteries-$(VERSION).tar.gz
+	  | gzip -9 > batteries-$(VERSION).tar.gz
 
 setup.ml: _oasis
 	oasis setup
 	git commit setup.ml -m"Update setup.ml based on _oasis"
-
 
 # uploads the current documentation to github hdoc2/ directory
 upload-docs:
@@ -303,6 +320,5 @@
 	cp /tmp/batteries.docdir/*.html hdoc2/ && \
 	git add hdoc2/*.html && \
 	git commit hdoc2 -m "Update ocamldoc to latest release" && \
-	git push \
-	git@github.com:ocaml-batteries-team/batteries-included.git gh-pages \
+	git push origin gh-pages && \
 	git checkout master

=== debian/changelog ===
ocaml-batteries (3.4.0-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Jan 2022 10:55:23 +0100

ocaml-batteries (3.4.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 17 Dec 2021 15:46:06 +0100

ocaml-batteries (3.3.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sun, 28 Nov 2021 10:28:43 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libnum-ocaml-dev,
  ocamlbuild,
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-batteries.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-batteries

## ocaml-batteries 3.5.1

=== debian/changelog ===
ocaml-batteries (3.5.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 03 Mar 2022 14:26:23 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Mehdi Dogguy <mehdi@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml-nox (>= 4),
+ ocaml,
  ocaml-findlib,
  libounit-ocaml-dev,
  libnum-ocaml-dev,

## ocaml-batteries 3.6.0

=== debian/changelog ===
ocaml-batteries (3.6.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 21 Jan 2023 09:31:06 +0100

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
  ocaml-findlib,
  libounit-ocaml-dev,
  libnum-ocaml-dev,
+ libcamlp-streams-ocaml-dev,
  ocamlbuild,
  dh-ocaml
 Standards-Version: 4.6.0

=== debian/rules ===
--- 
+++ 
@@ -42,9 +42,4 @@
 override_dh_compress:
 	dh_compress -Xmyocamlbuild.ml -X.idex
 
-.PHONY: override_dh_auto_build override_dh_auto_test override_dh_auto_install
-.PHONY: override_dh_auto_clean override_dh_compress
-
-.PHONY: override_dh_install
-override_dh_install:
-	dh_install --fail-missing
+override_dh_dwz:

## ocaml-batteries 3.7.2

=== Makefile ===
.PHONY: all clean install uninstall reinstall test doc

all:
	dune build @all

clean:
	dune clean

install:
	dune build @install
	dune install

uninstall:
	dune uninstall

test:
	dune runtest

doc:
	dune build @all
	dune build @doc

test_install:
	./scripts/test_install.sh

reinstall:
	dune uninstall
	dune build @install
	dune install


###############################################################################
#	BENCHMARK SUITE
###############################################################################

bench:
	$(OCAMLBUILD) $(OCAMLBUILDFLAGS) $(TARGETS) $(BENCH_TARGETS)
	$(RM) bench.log
	$(foreach BENCH, $(BENCH_TARGETS), _build/$(BENCH) | tee -a bench.log; )
	@echo "Benchmarking results are written to bench.log"


###############################################################################
#	PREPARING RELEASE FILES
###############################################################################

release:
	$(MAKE) clean
	git stash save "stashing local modifications before release"
	$(MAKE) release-cleaned

# assumes irreproachably pristine working directory
release-cleaned: doc test-native
	git archive --format=tar --prefix=batteries-$(VERSION)/ HEAD \
	  | gzip -9 > batteries-$(VERSION).tar.gz

# uploads the current documentation to github hdoc2/ directory
upload-docs:
	make doc && \
	rm -rf /tmp/batteries.docdir && \
	cp -a _build/batteries.docdir /tmp/ && \
	git checkout gh-pages && \
	rm -f hdoc2/*.html && \
	cp /tmp/batteries.docdir/*.html hdoc2/ && \
	git add hdoc2/*.html && \
	git commit hdoc2 -m "Update ocamldoc to latest release" && \
	git push origin gh-pages && \
	git checkout master

=== examples/euler/Makefile ===
.PHONY: all clean

SOURCES = $(wildcard euler*.ml)
TARGETS = $(SOURCES:.ml=.byte)
LIBRARIES = mathlib.ml

all: $(TARGETS)

clean:
	rm *.byte *.native *.cmi *.cmo

%.byte: $(LIBRARIES) %.ml
	ocamlfind ocamlc -thread -package threads,batteries -linkpkg $^ -o $@

%.native: $(LIBRARIES) %.ml
	ocamlfind ocamlc -thread -package threads,batteries -linkpkg $^ -o $@

=== debian/changelog ===
ocaml-batteries (3.7.2-1build1) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Feb 2024 01:19:11 +0100

ocaml-batteries (3.7.2-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 15 Feb 2024 08:29:22 +0100

ocaml-batteries (3.7.1-3) unstable; urgency=medium

  * Team upload
  * Remove one test that fails on mips64el and hppa (at least)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 01 Oct 2023 06:48:18 +0200

ocaml-batteries (3.7.1-2) unstable; urgency=medium

  * Team upload
  * Fix compilation on 32-bit architectures

 -- Stéphane Glondu <glondu@debian.org>  Sun, 01 Oct 2023 03:38:50 +0200

ocaml-batteries (3.7.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Sat, 30 Sep 2023 21:57:41 +0200

## ocaml-batteries 3.8.0

=== debian/changelog ===
ocaml-batteries (3.8.0-2build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:42:19 +0200

ocaml-batteries (3.8.0-2) unstable; urgency=medium

  * Team upload
  * Do not hardcode /usr/lib/ocaml

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Aug 2024 09:45:42 +0200

ocaml-batteries (3.8.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 04 Jun 2024 06:12:23 +0200

## ocaml-batteries 3.9.0

=== examples/benchmark/Makefile ===
TESTS:=nth map folr map2 append flatten filter1 filter2 mapx folrx
OPTS:=--max-i 10_000_000

all: t_enum.byte

t_enum.byte t_enum.native: t_enum.ml
	ocamlbuild t_enum.byte t_enum.native

pngs: $(addsuffix .png, $(TESTS))

t_list.byte t_list.native: t_list.ml
	ocamlbuild t_list.byte t_list.native

%.gallium_byte: t_list.byte
#The following doesn't succeed for large I -- not tail-recursive
	- ./t_list.byte $(OPTS) -g $(basename $@) > $@

%.extlib_byte: t_list.byte
	./t_list.byte $(OPTS) -e $(basename $@) > $@

%.blue_byte: t_list.byte
	./t_list.byte $(OPTS) -b $(basename $@) > $@

%.core_byte: t_list.byte
	./t_list.byte $(OPTS) -c $(basename $@) > $@

%.gallium_native: t_list.native
#The following doesn't succeed for large I -- not tail-recursive
	- ./t_list.native $(OPTS) -g $(basename $@) > $@

%.extlib_native: t_list.native
	./t_list.native $(OPTS) -e $(basename $@) > $@

%.blue_native: t_list.native
	./t_list.native $(OPTS) -b $(basename $@) > $@

%.core_native: t_list.native
	./t_list.native $(OPTS) -c $(basename $@) > $@

%.png: %.gallium_byte %.extlib_byte %.blue_byte %.core_byte %.gallium_native %.extlib_native %.blue_native %.core_native
	TEST=$(basename $@)
	echo "set logscale x; set logscale y; set terminal png; set xlabel \"List Length\"; set ylabel \"List-operations per second\"; set output \"$@\"; plot \"$(basename $@).gallium_byte\" w lp, \"$(basename $@).extlib_byte\" w lp, \"$(basename $@).blue_byte\" w lp, \"$(basename $@).core_byte\" w lp, \"$(basename $@).gallium_native\" w lp, \"$(basename $@).extlib_native\" w lp, \"$(basename $@).blue_native\" w lp, \"$(basename $@).core_native\" w lp" | gnuplot

t_byte: $(addsuffix .gallium_byte, $(TESTS)) $(addsuffix .extlib_byte, $(TESTS))

clean:
	ocamlbuild -clean
	- rm *.*_byte *.*_native
	- rm *.png

=== debian/changelog ===
ocaml-batteries (3.9.0-2) unstable; urgency=medium

  * Team upload
  * Fix Build-Depends for nocheck profile (Closes: #1116828)
  * Bump Standards-Version to 4.7.2
  * Bump debian/watch version to 5

 -- Stéphane Glondu <glondu@debian.org>  Sat, 04 Oct 2025 09:47:22 +0200

ocaml-batteries (3.9.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 14 Jan 2025 08:39:51 +0100

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,17 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml,
- ocaml-findlib,
+ ocaml-dune,
  libounit-ocaml-dev,
  libnum-ocaml-dev,
  libcamlp-streams-ocaml-dev,
- ocamlbuild,
- dh-ocaml
-Standards-Version: 4.6.0
+ ocaml-qtest <!nocheck>,
+ libqtest-ocaml-dev <!nocheck>,
+ libqcheck-ocaml-dev <!nocheck>,
+ libbenchmark-ocaml-dev,
+ ocaml-odoc <!nodoc>,
+ dh-ocaml (>= 2)
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-batteries.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-batteries

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

override_dh_auto_build:
	dh_auto_build -- @all @doc

=== debian/watch ===
Version: 5

Source: https://github.com/ocaml-batteries-team/batteries-included/tags
Matching-Pattern: .*/@ANY_VERSION@\.tar\.gz
Uversionmangle: s/_test_/~test~/

## ocaml-batteries 3.10.0

=== debian/changelog ===
ocaml-batteries (3.10.0-1build3) resolute; urgency=medium

  * No change rebuild with fixed amd64v3 builders

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 27 Feb 2026 23:58:04 +0100

ocaml-batteries (3.10.0-1build2) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 26 Jan 2026 20:31:37 +0100

ocaml-batteries (3.10.0-1build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Jan 2026 00:33:36 +0100

ocaml-batteries (3.10.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 18 Dec 2025 10:40:02 +0100
